#include <windows.h>

// Handle of DLL
HINSTANCE	nviewlib;
// Function Prototype
typedef (*NVIEWLIBCALL)(LPTSTR,BOOL);
NVIEWLIBCALL nviewlibload,nviewlibwidth,nviewlibheight,nviewlibsaveasjpg;


// Loads JPG,JIF,GIF,BMP,DIB,RLE,TGA,PCX
HBITMAP NVLoadPicture(char *name)
{

	HBITMAP pic;
	_asm {
		push	0
		mov	eax,name
		push	eax
		call	[nviewlibload]
		mov	pic,eax
	}
	return(pic);
}


int NVSavePicture(int quality,char *name)
{
	int w;
	_asm {
		mov	eax,name
		push	eax
		mov	eax,quality
		push	eax
		call	[nviewlibsaveasjpg]
		mov	w,eax
	}
	return(w);
}


// Returns the width in Pixel of the picture
int NVGetWidth()
{
	int w;
	_asm {
		call	[nviewlibwidth]
		mov	w,eax
	}
	return(w);
}


// Returns the height in Pixel of the picture
int NVGetHeight()
{
	int h;
	_asm {
		call	[nviewlibheight]
		mov	h,eax
	}
	return(h);
}


// Initialize the dll
BOOL NVInitLib()
{
	nviewlib = LoadLibrary("NViewLib.dll");
	if(nviewlib == NULL) return(FALSE);
	nviewlibload = (NVIEWLIBCALL)GetProcAddress(nviewlib,"NViewLibLoad");
	if(nviewlibload == NULL)
	{
		FreeLibrary(nviewlib);
		return(FALSE);
	}
	nviewlibwidth = (NVIEWLIBCALL)GetProcAddress(nviewlib,"GetWidth");
	if(nviewlibwidth == NULL)
	{
		FreeLibrary(nviewlib);
		return(FALSE);
	}
	nviewlibheight = (NVIEWLIBCALL)GetProcAddress(nviewlib,"GetHeight");
	if(nviewlibheight == NULL)
	{
		FreeLibrary(nviewlib);
		return(FALSE);
	}
	nviewlibsaveasjpg = (NVIEWLIBCALL)GetProcAddress(nviewlib,"NViewLibSaveAsJPG");
	if(nviewlibsaveasjpg == NULL)
	{
		FreeLibrary(nviewlib);
		return(FALSE);
	}
	return(TRUE);
}


// Remove the dll
void NVFreeLib()
{
	FreeLibrary(nviewlib);
}
