//#define DEMO
//#define NOPRINT


#include <windows.h>
#include <winuser.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>
#include <commctrl.h>
#include <shlobj.h>
#include <vfw.h>
#include <math.h>
#include <richedit.h>
#include "myrtf.h"
#include "resource.h"

#define	DLG_INIT		15000
#define	DLG_RELEASE	15001

BOOL CALLBACK StartupProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam);
BOOL CALLBACK MainProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam);
BOOL CALLBACK Mask1Proc(HWND hwnd,UINT msg,UINT wparam,LONG lparam);
BOOL CALLBACK Mask2Proc(HWND hwnd,UINT msg,UINT wparam,LONG lparam);
BOOL CALLBACK Mask3Proc(HWND hwnd,UINT msg,UINT wparam,LONG lparam);

HWND hwnd_mask1,hwnd_mask2,hwnd_mask3;

typedef struct
{
	BYTE flag;
	BYTE selection[25];
} FACE;

typedef struct
{
	int xs;
	int ys;
	int num;
	char *restext;
} FACETYPE;


FACETYPE facetype[25] =
{
	{98,112,7,"FACESHAPES"},
	{96,72,7,"HAIRLINE"},
	{59,69,6,"FOREHEAD"},
	{100,48,14,"EYEBROWS"},
	{100,36,22,"EYESPICS"},
	{100,29,1,"EYECROSSES"},
	{120,124,3,"CROWSFEET"},
	{70,84,13,"NOSEPICS"},
	{100,50,4,"TEETHPICS"},
	{128,135,4,"CHINPICS"},
	{100,100,3,"CHINCLEFT"},
	{100,100,4,"CHEEKBONES"},
	{100,112,19,"EARSPICS"},
	{120,99,7,"FOREHEADLINES"},
	{100,100,1,"DESTINYDIMPLE"},
	{118,102,8,"FOREHEADCREASES"},
	{126,86,6,"GROOVE"},
	{100,100,1,"DESIRABILITYLINE"},
	{100,100,2,"DISAPPOINTMENTLINE"},
	{100,100,2,"COMPASSIONLINE"},
	{128,164,1,"MENTALPRESSURELINE"},
	{100,104,15,"MOLESPICS"},
	{100,100,1,"SURVIVORLINE"},
	{77,32,6,"LIPSPICS"},
	{100,100,2,"RESPONSIBILITYLINES"}
};

FACE face[25];


char wintitle[160];

HINSTANCE myinstance;
void FillRichEdit(HWND hwnd);
BOOL PrintRtf(HWND hwnd);
HWND hwnd_status;


DWORD analysis;		// total of analysis made

int InstallFont(char *ttfname)
{
	char fontpath[MAX_PATH],systempath[MAX_PATH];
	char buf[MAX_PATH],buf1[MAX_PATH];
	LPITEMIDLIST idl;
	HRSRC res;
	BYTE *ptr;
	int fn;
	SHGetSpecialFolderLocation(NULL,CSIDL_FONTS,&idl);
	SHGetPathFromIDList(idl,(LPSTR)&fontpath);
	GetSystemDirectory(systempath,sizeof(systempath));
	sprintf(buf,"%s\\%s.ttf",fontpath,ttfname);
	sprintf(buf1,"%s\\%s.fot",systempath,ttfname);
	if((access(buf,0) == 0) && (access(buf1,0) == 0)) return(0);
	res = FindResource(myinstance,ttfname,"FONTRES");
	if(res == NULL) return(0);
	ptr = (BYTE *) LockResource(LoadResource(myinstance,res));
	fn = open(buf,O_CREAT|O_BINARY|O_TRUNC|O_WRONLY,S_IREAD|S_IWRITE);
	write(fn,ptr,SizeofResource(myinstance,res));
	close(fn);
	CreateScalableFontResource(0,buf1,buf,NULL);
	AddFontResource(buf1);
	SendMessage(HWND_BROADCAST,WM_FONTCHANGE,0,0L);
	return(1);
}


int WINAPI WinMain(HINSTANCE hinstance,HINSTANCE hprevinstance,LPSTR cmdline,int cmdshow)
{
	INITCOMMONCONTROLSEX cex;

	myinstance = hinstance;
	cex.dwSize = sizeof(INITCOMMONCONTROLSEX);
	cex.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&cex);
	InstallFont("verdana");
	InstallFont("verdanab");
	InstallFont("verdanai");
	InstallFont("verdanaz");
	InitMyRtf();
	strcpy(wintitle,"FaceReader Prof. V1.0, (C)2000 Softtouch Software Design - http://ssd-ph.hypermart.net");
	if(DialogBox(hinstance,"StartupDialog",NULL,(DLGPROC)StartupProc) == 1)
	DialogBox(hinstance,"MainDialog",NULL,(DLGPROC)MainProc);
	return(0);
}


void Status_Records()
{
	char buf[50];
	sprintf(buf,"Analysis: %u",analysis);
	SendMessage(hwnd_status,SB_SETTEXT,1,(LPARAM)buf);
}


/************************************************
 * Writes the date and time into the status bar *
 ************************************************/
void Status_Datum()
{
	char buf[50];
	time_t zeit;
	struct tm *tm;
	zeit = time(NULL);
	tm = localtime(&zeit);
	strftime(buf,sizeof(buf)," %m/%d/%Y",tm);
	SendMessage(hwnd_status,SB_SETTEXT,2,(LPARAM)buf);
	strftime(buf,sizeof(buf)," %I:%M %S %p",tm);
	SendMessage(hwnd_status,SB_SETTEXT,3,(LPARAM)buf);
}

DWORD LoadAnalysis()
{
	DWORD num;
	int fn;
	if(access(".\\analysis.dat",0) == -1) return(0);
	fn = open(".\\analysis.dat",O_BINARY|O_RDONLY);
	read(fn,&num,4);
	close(fn);
	return(num);
}


void SaveAnalysis()
{
	int fn;
	fn = open(".\\analysis.dat",O_BINARY|O_WRONLY|O_CREAT|O_TRUNC,S_IREAD|S_IWRITE);
	write(fn,&analysis,4);
	close(fn);
}


BOOL CALLBACK StartupProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam)
{
	static int retcode;
	switch(msg)
	{
		case	WM_INITDIALOG:
					SetWindowText(hwnd,wintitle);
					retcode = 0;
#ifdef DEMO
					ShowWindow(GetDlgItem(hwnd,IDC_DEMOTXT),SW_SHOW);
#else
					ShowWindow(GetDlgItem(hwnd,IDC_DEMOTXT),SW_HIDE);
#endif
					return(TRUE);
		case	WM_DESTROY:
					EndDialog(hwnd,retcode);
					break;
		case	WM_CLOSE:
					if(MessageBox(hwnd,"Exit FaceReader?","User prompt",MB_YESNO|MB_ICONQUESTION) == IDYES)
					{
						SendMessage(hwnd,WM_DESTROY,0,0L);
						retcode = 0;
					}
					break;
		case	WM_COMMAND:
					switch(LOWORD(wparam))
					{
						case	IDC_START:
									retcode = 1;
									SendMessage(hwnd,WM_DESTROY,0,0L);
									break;
						case	IDC_EXIT:
									SendMessage(hwnd,WM_CLOSE,0,0L);
									break;
					}
					break;
	}
	return(FALSE);
}


BOOL CALLBACK MainProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam)
{
	static PAINTSTRUCT ps;
	static RECT rc;
	static int mainsbarwidth[4];
	switch(msg)
	{
		case	WM_INITDIALOG:
					SetWindowText(hwnd,wintitle);
					analysis = LoadAnalysis();
					GetWindowRect(hwnd,&rc);
					hwnd_status = CreateWindowEx(0L,STATUSCLASSNAME,"",WS_CHILD|WS_VISIBLE,0,0,0,0,hwnd,(HMENU)0,myinstance,NULL);
					mainsbarwidth[3] = -1;
					mainsbarwidth[2] = rc.right-rc.left-80;
					mainsbarwidth[1] = mainsbarwidth[2]-72;
					mainsbarwidth[0] = mainsbarwidth[1]-96;
					SendMessage(hwnd_status,SB_SETPARTS,4,(LPARAM)mainsbarwidth);
					SetClassLong(GetDlgItem(hwnd,IDC_EXIT),GCL_HCURSOR,(long)LoadCursor(myinstance,"HAND"));
					Status_Datum();
					Status_Records();
					hwnd_mask1 = CreateDialog(myinstance,"Mask1",hwnd,Mask1Proc);
					hwnd_mask2 = CreateDialog(myinstance,"Mask2",hwnd,Mask2Proc);
					hwnd_mask3 = CreateDialog(myinstance,"Mask3",hwnd,Mask3Proc);
					ShowWindow(hwnd_mask1,TRUE);
					ShowWindow(hwnd_mask2,FALSE);
					ShowWindow(hwnd_mask3,FALSE);
					SetTimer(hwnd,1,1000,NULL);
					return(TRUE);
		case	WM_TIMER:
					Status_Datum();
					break;
		case	WM_DESTROY:
					DestroyWindow(hwnd_mask1);
					DestroyWindow(hwnd_mask2);
					DestroyWindow(hwnd_mask3);
					EndDialog(hwnd,TRUE);
					break;
		case	WM_CLOSE:
					if(MessageBox(hwnd,"Exit FaceReader?","User prompt",MB_YESNO|MB_ICONQUESTION) == IDYES)
					SendMessage(hwnd,WM_DESTROY,0,0L);
					break;
		}
	return(FALSE);
}


void ShowStatus(HWND hwnd)
{
	int i,done;

	done = 0;
	for(i=0; i<25; i++)
	{
		if(face[i].flag == 1)
		{
			SetWindowText(GetDlgItem(hwnd,21000+i),"DONE");
			done = 1;
		}
		else SetWindowText(GetDlgItem(hwnd,21000+i),"");
	}

	if(!done) EnableWindow(GetDlgItem(hwnd,IDC_CREATE),FALSE);
	else EnableWindow(GetDlgItem(hwnd,IDC_CREATE),TRUE);
}



BOOL CALLBACK Mask1Proc(HWND hwnd,UINT msg,UINT wparam,LONG lparam)
{
	static int i;
	switch(msg)
	{
		case	WM_INITDIALOG:
					ZeroMemory(face,sizeof(face));
					ShowStatus(hwnd);
#ifdef DEMO
					for(i=20003; i<20025; i++) EnableWindow(GetDlgItem(hwnd,i),FALSE);
#endif
					return(TRUE);
		case	DLG_INIT:
					ShowStatus(hwnd);
#ifdef DEMO
					MessageBox(hwnd,"Only 3 parts of the head are available in this demo version!\r\nPlease register for the full version\r\nand have all features available!","Register at http://www.mysteryworld.org",MB_OK|MB_ICONINFORMATION);
#endif
					break;
		case	DLG_RELEASE:
					break;
		case	WM_COMMAND:
					if((LOWORD(wparam) >= 20000) && (LOWORD(wparam) < 21000))
					{
						SendMessage(hwnd_mask2,DLG_INIT,0,LOWORD(wparam)-20000);
						ShowWindow(hwnd_mask2,SW_SHOW);
						ShowWindow(hwnd_mask1,SW_HIDE);
					}
					switch(LOWORD(wparam))
					{
						case	IDC_EXIT:
									SendMessage(GetParent(hwnd),WM_CLOSE,0,0L);
									break;
						case	IDC_CREATE:
									SendMessage(hwnd_mask3,DLG_INIT,0,0);
									ShowWindow(hwnd_mask3,SW_SHOW);
									ShowWindow(hwnd_mask1,SW_HIDE);
									break;
						case	IDC_RESET:
									ZeroMemory(face,sizeof(face));
									ShowStatus(hwnd);
									break;
					}
					break;
		}
	return(FALSE);
}


BOOL WINAPI InitListView(HWND hwndLV,char *title)
{ 
	LVCOLUMN lvc; 
	RECT rc;
	GetClientRect(hwndLV,&rc);
	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM; 
	lvc.fmt = LVCFMT_LEFT;
	lvc.cx = rc.right-rc.left-2;
	lvc.iSubItem = 0;
	lvc.pszText = title;  
	ListView_InsertColumn(hwndLV,0,&lvc);
	return(TRUE);
}


HIMAGELIST himl;


HBITMAP CreateImageCopy(HWND hwnd,long type,int num)
{
	HDC hdc,hdcmem,hdcmem1;
	HBITMAP hbmp1,hbmp2;

	hdc = GetDC(hwnd);
	hdcmem = CreateCompatibleDC(hdc);
	hdcmem1 = CreateCompatibleDC(hdc);

	hbmp1 = (HBITMAP)LoadImage(myinstance,facetype[type].restext,IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION); 
	hbmp2 = CreateCompatibleBitmap(hdc,facetype[type].xs,facetype[type].ys);
	SelectObject(hdcmem,hbmp1);	
	SelectObject(hdcmem1,hbmp2);
	BitBlt(hdcmem1,0,0,facetype[type].xs,facetype[type].ys,hdcmem,0,facetype[type].ys * num,SRCCOPY);
	DeleteDC(hdcmem1);
	DeleteDC(hdcmem);
	ReleaseDC(hwnd,hdc);
	DeleteObject(hbmp1);
	return(hbmp2);
}

HIMAGELIST InitListViewImages(HWND hwndLV,long type)
{
	HBITMAP hiconItem;
	int i;

	himl = ImageList_Create(facetype[type].xs,facetype[type].ys,ILC_COLOR24,facetype[type].num,1);

	for(i=0; i<facetype[type].num; i++)
	{
		hiconItem = CreateImageCopy(GetParent(hwndLV),type,i);
		ImageList_Add(himl,hiconItem,NULL);
		DeleteObject(hiconItem);  
	}

	ListView_SetImageList(hwndLV,himl,LVSIL_NORMAL);
	return(himl);
}

void FillListView(HWND hwndLV,long type)
{
	LVITEM lvi;  
	int i,x,z;
	HRSRC res;
	BYTE *ptr;
	char buf[160];

	lvi.mask = LVIF_TEXT | LVIF_STATE | LVIF_IMAGE | LVIF_PARAM; 
	lvi.state = 0;
	lvi.stateMask = 0;

	res = FindResource(myinstance,facetype[type].restext,"DESCRIPTION");
	ptr = (BYTE *) LockResource(LoadResource(myinstance,res));

	z = 0;
	for(i=0; i<facetype[type].num; i++)
	{
		x = 0; while(ptr[z] != 0x0d) buf[x++] = ptr[z++];
		buf[x] = 0;
		z += 2;
		lvi.pszText = buf;
		lvi.iItem = i; 
		lvi.iSubItem = 0;
		lvi.iImage = i;
		ListView_InsertItem(hwndLV, &lvi);  
	}
}


void InitializeList(HWND hwnd,long type)
{
	int i,items;
	ImageList_Destroy(himl);
	ListView_DeleteAllItems(GetDlgItem(hwnd,IDC_LISTVIEW));
	InitListView(GetDlgItem(hwnd,IDC_LISTVIEW),"FaceReader");
	InitListViewImages(GetDlgItem(hwnd,IDC_LISTVIEW),type);
	FillListView(GetDlgItem(hwnd,IDC_LISTVIEW),type);

	items = ListView_GetItemCount(GetDlgItem(hwnd,IDC_LISTVIEW));

	for(i=0; i<items; i++)
	{
		if(face[type].selection[i])
		{
			ListView_SetItemState(GetDlgItem(hwnd,IDC_LISTVIEW),i,LVIS_SELECTED,LVIS_SELECTED);
		}
		else
		{
			ListView_SetItemState(GetDlgItem(hwnd,IDC_LISTVIEW),i,0,LVIS_SELECTED);
		}
	}
}


int GetSelection(HWND hwnd,long type)
{
	int items,i;
	HWND hwndLV;

	hwndLV = GetDlgItem(hwnd,IDC_LISTVIEW);
	items = ListView_GetItemCount(hwndLV);
	ZeroMemory(face[type].selection,sizeof(face[type].selection));
	face[type].flag = 0;
	for(i=0; i<items; i++)
	{
		if(ListView_GetItemState(hwndLV,i,LVIS_SELECTED) == LVIS_SELECTED)
		{
			face[type].selection[i] = 1;
			face[type].flag = 1;
		}
	}
	if(face[type].flag) return(1);
	else return(0);
}


void DeselectAll(HWND hwnd,long type)
{
	ZeroMemory(face[type].selection,sizeof(face[type].selection));
	face[type].flag = 0;
	ListView_SetItemState(GetDlgItem(hwnd,IDC_LISTVIEW),-1,0,LVIS_SELECTED);
}


BOOL CALLBACK Mask2Proc(HWND hwnd,UINT msg,UINT wparam,LONG lparam)
{
	static long type;
	static LPNMITEMACTIVATE lpnmia;
	switch(msg)
	{
		case	WM_INITDIALOG:
					type = -1;
					return(TRUE);
		case	DLG_INIT:				// LPARAM = Button ID (0-24)
					type = lparam;
					InitializeList(hwnd,type);
					break;
		case	DLG_RELEASE:
					ImageList_Destroy(himl);
					break;
		case	WM_NOTIFY:
					lpnmia = (LPNMITEMACTIVATE)lparam;
					if(lpnmia->hdr.code == LVN_ITEMACTIVATE)
					{
						if(lpnmia->iItem != -1) SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(IDC_OK,0),0L);
					}
					break;
		case	WM_COMMAND:
					switch(LOWORD(wparam))
					{
						case	IDC_OK:
									if(GetSelection(hwnd,type))
									{
										SendMessage(hwnd_mask1,DLG_INIT,1,type);
										ShowWindow(hwnd_mask1,SW_SHOW);
										ShowWindow(hwnd_mask2,SW_HIDE);
									}
									else MessageBox(hwnd,"Please choose at least one property!","Error",MB_OK|MB_ICONSTOP);
									break;
						case	IDC_CANCEL:
									SendMessage(hwnd_mask1,DLG_INIT,-1,type);
									ShowWindow(hwnd_mask1,SW_SHOW);
									ShowWindow(hwnd_mask2,SW_HIDE);
									break;
						case	IDC_DESELALL:
									DeselectAll(hwnd,type);
									break;
					}
	}
	return(FALSE);
}



BOOL CALLBACK Mask3Proc(HWND hwnd,UINT msg,UINT wparam,LONG lparam)
{
	static int i;
	switch(msg)
	{
		case	WM_INITDIALOG:
					return(TRUE);
		case	DLG_INIT:
					FillRichEdit(GetDlgItem(hwnd,IDC_RICHEDIT));
					break;
		case	DLG_RELEASE:
					break;
		case	WM_COMMAND:
					switch(LOWORD(wparam))
					{
						case	IDCANCEL:
									ShowWindow(hwnd_mask1,SW_SHOW);
									ShowWindow(hwnd_mask3,SW_HIDE);
									break;
						case	IDOK:
#ifndef NOPRINT
									PrintRtf(GetParent(hwnd));
									ShowWindow(hwnd_mask1,SW_SHOW);
									ShowWindow(hwnd_mask3,SW_HIDE);
#else
MessageBox(hwnd,"Printing is only available in the registered version!","Message",MB_OK|MB_ICONINFORMATION);
#endif
									break;
					}
					break;
		}
	return(FALSE);
}


char analysistext[20000];

void CreateAnalysis()
{
	int i,j,x;
	HRSRC res;
	char *ptr;
	DWORD len;
	char *adr,buf[80],tmp[10000];

	res = FindResource(myinstance,"ANALYSISTEXT","ANALYSIS");
	ptr = (char *) LockResource(LoadResource(myinstance,res));
	len = SizeofResource(myinstance,res);

	ZeroMemory(&analysistext,sizeof(analysistext));

	adr = strstr(ptr,"#0000");
	while(*adr++ != 0x0d) {} adr++;
	x = 0; while(*adr != '#') tmp[x++] = *adr++; tmp[x] = 0;
	strcat(analysistext,tmp);
	strcat(analysistext,"\r\n");

#ifdef DEMO
	for(i=0; i<3; i++)
#else
	for(i=0; i<25; i++)
#endif
	{
		for(j=0; j<facetype[i].num; j++)
		{
			if(face[i].selection[j] == 1)
			{
				sprintf(buf,"#%02d%02d",i+1,j+1);
				adr = strstr(ptr,buf);
				if(adr)
				{
					while(*adr++ != 0x0d) {} adr++;
					x = 0; while(*adr != '#') tmp[x++] = *adr++; tmp[x] = 0;
					strcat(analysistext,tmp);
					strcat(analysistext,"\r\n");
				}
			}
		}
	}
	adr = strstr(ptr,"#0001");
	while(*adr++ != 0x0d) {} adr++;
	x = 0; while(*adr != '#') tmp[x++] = *adr++; tmp[x] = 0;
	strcat(analysistext,tmp);
#ifdef DEMO
	strcat(analysistext,"\r\nPlease register to receive the full version of FaceReader!\r\n");
#endif
}


void FillRichEdit(HWND hwnd_riched)
{
	CHARFORMAT charform;
	memset(&charform,0,sizeof(CHARFORMAT));
	charform.cbSize = sizeof(CHARFORMAT);
	charform.dwMask = CFM_FACE | CFM_COLOR | CFM_SIZE;
	charform.yHeight = 57 * 3;
	charform.crTextColor = RGB(0,0,0);
	strcpy(charform.szFaceName,"verdana");
	if(SendMessage(hwnd_riched,EM_SETCHARFORMAT,(WPARAM)SCF_ALL,(LPARAM)&charform) == 0)
	{
		strcpy(charform.szFaceName,"times new roman");
		SendMessage(hwnd_riched,EM_SETCHARFORMAT,(WPARAM)SCF_ALL,(LPARAM)&charform);
	}
	CreateAnalysis();
	SendMessage(hwnd_riched,WM_SETTEXT,0,(LPARAM)&analysistext);
}



void FillPrinterRichEdit(HWND hwnd_riched)
{
	CHARFORMAT charform;
	memset(&charform,0,sizeof(CHARFORMAT));
	charform.cbSize = sizeof(CHARFORMAT);
	charform.dwMask = CFM_FACE | CFM_COLOR | CFM_SIZE;
	charform.yHeight = 57 * 4;
	charform.crTextColor = RGB(0,0,0);
	strcpy(charform.szFaceName,"verdana");
	if(SendMessage(hwnd_riched,EM_SETCHARFORMAT,(WPARAM)SCF_ALL,(LPARAM)&charform) == 0)
	{
		strcpy(charform.szFaceName,"times new roman");
		SendMessage(hwnd_riched,EM_SETCHARFORMAT,(WPARAM)SCF_ALL,(LPARAM)&charform);
	}
	CreateAnalysis();
	SendMessage(hwnd_riched,WM_SETTEXT,0,(LPARAM)&analysistext);
}

#ifndef NOPRINT

/*****************
 * PRINTER STUFF *
 *****************/
BOOL abortprinting;
HWND hDlgPrint;
BOOL CALLBACK ReqProc(HWND hwnd,UINT msg,UINT wparam,LONG lparam)
{
	switch(msg)
	{
		case	WM_INITDIALOG:
					hDlgPrint = hwnd;
					abortprinting = FALSE;
					return(TRUE);
		case	WM_DESTROY:
					EndDialog(hwnd,TRUE);
					return(TRUE);
		case	WM_CLOSE:
					SendMessage(hwnd,WM_DESTROY,0,0L);
					return(TRUE);
		case	WM_COMMAND:
					switch(LOWORD(wparam))
					{
						case	IDCANCEL:
									abortprinting = TRUE;
									DestroyWindow(hwnd);
									break;
					}
	}
	return(FALSE);
}


BOOL CALLBACK AbortProc(HDC hdc,int error)
{
	MSG msg;
	while(!abortprinting && PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	{ 
		if(!hDlgPrint || !IsDialogMessage(hDlgPrint,&msg))
		{ 
			TranslateMessage(&msg); 
			DispatchMessage (&msg); 
		} 
	} 
	return !abortprinting; 
}


typedef struct
{
	float xPerInch;			// Pixel per Inch
	float yPerInch;			// Pixel per Inch
	float xPerMM;				// Pixel per MM
	float yPerMM;				// Pixel per MM
	float xPixelPage;		// Page width in Pixel
	float yPixelPage;		// Page height in Pixel
	float	xInchPage;		// Page width in Inch
	float yInchPage;		// Page height in Inch
	float xMMPage;			// Page width in MM
	float yMMPage;			// Page height in MM
	float xPixelOffset;	// Left offset in Pixel
	float yPixelOffset;	// Top offset in Pixel
	float xInchOffset;	// Left offset in Inch
	float yInchOffset;	// Top offset in Inch
	float xMMOffset;		// Left offset in MM
	float yMMOffset;		// Top offset in MM
	int printercolors;
	int caps;
	RECT mm_area;				// Printable area in MM
	RECT twips_area;		// Printable area in TWIPS
	RECT pixel_area;		// Printable area in Pixel
	RECT mm_margins;		// User defines of margins in mm
	PRINTDLG pd;				// Printer Dialog Structure
	DOCINFO di;					// DOCINFO
	int rtf;						// 0 = NO RTF, 1 = RTF
} PAGE;

#define	TWIPS_PER_INCH	(float)1440.0f
#define	TWIPS_PER_MM	((float)TWIPS_PER_INCH / 25.4f)
#define	IN_MMX(x) (x*page.xPerMM)
#define	IN_MMY(x) (x*page.yPerMM)

BOOL ChoosePrinter(HWND hwnd,PAGE *page,char *txt)
{
	ZeroMemory(&page->pd,sizeof(PRINTDLG));
	page->pd.lStructSize = sizeof(PRINTDLG);
	page->pd.hwndOwner = hwnd;
	page->pd.hInstance = myinstance;
	page->pd.nFromPage = 0;
	page->pd.nToPage = 0;
	page->pd.nMinPage = 0;
	page->pd.nMaxPage = 0;
	page->pd.nCopies = 1;
	page->pd.Flags = PD_NOPAGENUMS|PD_NOSELECTION|PD_USEDEVMODECOPIES|PD_COLLATE|PD_RETURNDC|PD_HIDEPRINTTOFILE|PD_NONETWORKBUTTON;
	if(!PrintDlg(&page->pd)) return(FALSE);

	ZeroMemory(&page->di,sizeof(DOCINFO));
	page->di.cbSize = sizeof(DOCINFO);
	page->di.lpszDocName = txt;
	page->di.lpszOutput = NULL;

	return(TRUE);
}


int PrintInit(HWND hwnd,PAGE *page)
{
	page->printercolors = GetDeviceCaps(page->pd.hDC,NUMCOLORS);
	page->caps = GetDeviceCaps(page->pd.hDC,RASTERCAPS);

	page->xPerInch = (float)GetDeviceCaps(page->pd.hDC,LOGPIXELSX);					// X Pixel Per Inch
	page->yPerInch = (float)GetDeviceCaps(page->pd.hDC,LOGPIXELSY);					// Y Pixel Per Inch
	page->xPerMM = page->xPerInch / 25.4f;																	// X Pixel Per MM
	page->yPerMM = page->yPerInch / 25.4f;																	// Y Pixel Per MM
	page->xPixelPage = (float)GetDeviceCaps(page->pd.hDC,PHYSICALWIDTH);		// Pagewidth in Pixel
	page->yPixelPage = (float)GetDeviceCaps(page->pd.hDC,PHYSICALHEIGHT);		// Pageheight in Pixel
	page->xInchPage = page->xPixelPage / page->xPerInch;
	page->yInchPage = page->yPixelPage / page->yPerInch;
	page->xMMPage = page->xPixelPage / page->xPerInch * 25.4f;
	page->yMMPage = page->yPixelPage / page->yPerInch * 25.4f;
	page->xPixelOffset = (float)GetDeviceCaps(page->pd.hDC,PHYSICALOFFSETX);// Pixel left offset
	page->yPixelOffset = (float)GetDeviceCaps(page->pd.hDC,PHYSICALOFFSETY);// Pixel right offset
	page->xInchOffset = page->xPixelOffset / page->xPerInch;
	page->yInchOffset = page->yPixelOffset / page->yPerInch;
	page->xMMOffset = page->xPixelOffset / page->xPerInch * 25.4f;
	page->yMMOffset = page->yPixelOffset / page->yPerInch * 25.4f;

// Define margins (MM)
	page->mm_margins.left = (long)(20.0f - page->xMMOffset);
	page->mm_margins.top = (long)(20.0f - page->yMMOffset);
	page->mm_margins.right = 20;
	page->mm_margins.bottom = 20;

// Calculate printable area in MM
	page->mm_area.left = page->mm_margins.left;
	page->mm_area.top = page->mm_margins.top;
	page->mm_area.right = (long)(page->xMMPage - page->mm_margins.right);
	page->mm_area.bottom = (long)(page->yMMPage - page->mm_margins.bottom);

// Calculate printable area in TWIPS
	page->twips_area.left = (long)(TWIPS_PER_MM * page->mm_area.left);			// left position in TWIPS
	page->twips_area.top = (long)(TWIPS_PER_MM * page->mm_area.top);				// top position in TWIPS
	page->twips_area.right = (long)(TWIPS_PER_MM * page->mm_area.right);
	page->twips_area.bottom = (long)(TWIPS_PER_MM * page->mm_area.bottom);

// Calculate the printable area in pixel
	page->pixel_area.left = (long)(page->mm_area.left * page->xPerMM);
	page->pixel_area.top = (long)(page->mm_area.top * page->yPerMM);
	page->pixel_area.right = (long)(page->mm_area.right * page->xPerMM);
	page->pixel_area.bottom = (long)(page->mm_area.bottom * page->yPerMM);


	return(1);
}


BOOL PrintRtf(HWND hwnd)
{
	char *errcodetext[] = {"StartDoc","StartPage","EndPage","EndDoc"};
	int errcode; 
	HWND hwnd_printer;
	HWND hwnd_requester;
	char buf[128];
	PAGE page;
//	char tmpdir[MAX_PATH];

	if(ChoosePrinter(hwnd,&page,"Facereading Printout") == FALSE) return(FALSE);

	PrintInit(hwnd,&page);

	hwnd_requester = CreateDialog(myinstance,"PrintDlg",hwnd,ReqProc);
	ShowWindow(hwnd_requester,SW_SHOW);
	UpdateWindow(hwnd_requester);
	hwnd_printer = GetDlgItem(hwnd_requester,IDC_RICHEDIT);
	FillPrinterRichEdit(hwnd_printer);
	SetAbortProc(page.pd.hDC,AbortProc);

	if(StartDoc(page.pd.hDC,&page.di) <= 0) {errcode = 1; goto err;}

	FORMATRANGE fr;
	long textlen;
	textlen = SendMessage(hwnd_printer,WM_GETTEXTLENGTH, 0, 0);
	fr.hdc = page.pd.hDC;
	fr.hdcTarget = 0;
	fr.rc = page.twips_area;
	fr.rcPage = page.twips_area;
	fr.chrg.cpMin = 0;
	fr.chrg.cpMax = textlen;
	do
	{
		if(StartPage(page.pd.hDC) <= 0) {errcode = 2; goto abort;}
		fr.chrg.cpMin = SendMessage(hwnd_printer,EM_FORMATRANGE,(WPARAM)TRUE,(LPARAM)&fr);
		if(EndPage(page.pd.hDC) <= 0) goto abort;
	} while(fr.chrg.cpMin > 0 && fr.chrg.cpMin < fr.chrg.cpMax);
	fr.chrg.cpMin = fr.chrg.cpMax = textlen;
	SendMessage(hwnd_printer,EM_FORMATRANGE,0,0);

	if(EndDoc(page.pd.hDC) <= 0) {errcode = 4; goto abort;}
	DeleteDC(page.pd.hDC);
	DestroyWindow(hwnd_requester);
	analysis++;
	SaveAnalysis();
	Status_Records();
	return(TRUE);

abort:
	AbortDoc(page.pd.hDC);
err:
	DeleteDC(page.pd.hDC);
	if(page.rtf)
	{
		fr.chrg.cpMin = fr.chrg.cpMax = textlen;
		SendMessage(hwnd_printer,EM_FORMATRANGE, 0, 0);
	}
	DestroyWindow(hwnd_requester);
	if(abortprinting == FALSE) sprintf(buf,"Printer Error!\r\nErrorcode: %d = %s",errcode,errcodetext[errcode-1]); 
	else strcpy(buf,"Printout aborted!");
	MessageBox(hwnd,buf,"Printout aborted",MB_ICONSTOP|MB_OK);
	return(FALSE);
}
#undef IN_MMX
#undef IN_MMY
#undef TWIPS_PER_INCH
#undef TWIPS_PER_MM

#endif
